/*! \file TriaP1ElementResult.h 
 *  \brief: header file for TriaP1ElementResult object
 */


#ifndef _TRIAP1ELEMENTRESULT_H_
#define _TRIAP1ELEMENTRESULT_H_

/*Headers:*/
/*{{{*/
#include "../Inputs/Input.h"
#include "../../include/include.h"
/*}}}*/

class TriaP1ElementResult: public ElementResult{

	private: 
		int    enum_type;
		IssmDouble values[3];
		int    step;
		IssmDouble time;

	public:

		/*TriaP1ElementResult constructors, destructors: {{{*/
		TriaP1ElementResult();
		TriaP1ElementResult(int enum_type,IssmDouble* values,int step,IssmDouble time);
		~TriaP1ElementResult();
		/*}}}*/
		/*Object virtual functions definitions:{{{ */
		void  Echo();
		void  DeepEcho();
		int   Id(); 
		int   MyRank();
		int   ObjectEnum();
		Object* copy();
		/*}}}*/
		/*ElementResult virtual functions definitions: {{{*/
		ElementResult* SpawnTriaElementResult(int* indices);
		IssmDouble  GetTime(void){return time;};
		int     GetStep(void){return step;};
		void    ProcessUnits(Parameters* parameters);
		int     NumberOfNodalValues(void);
		void    PatchFill(int row, Patch* patch);
		/*}}}*/
		/*TriaP1ElementResult management: {{{*/
		int   InstanceEnum();
		void GetVectorFromResults(Vector* vector,int* doflist,int* connectivitylist,int numdofs);
		void GetElementVectorFromResults(Vector* vector,int dof);
		/*}}}*/

};
#endif  /* _TRIAP1ELEMENTRESULT_H */
